"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var web_storage_1 = require("@ng2plus/web-storage");
var webSessionStorageConfig = {
    prefix: 'Modulab',
    provider: 'sessionStorage'
};
var SessionService = (function () {
    function SessionService(webStorageService) {
        this.webStorageService = webStorageService;
        this.webStorageService.setup(webSessionStorageConfig);
        this.convertPreferencesToAngular2();
    }
    SessionService.prototype.putPreference = function (key, value) {
        this.webStorageService
            .setup(webSessionStorageConfig)
            .set(key, value);
    };
    SessionService.prototype.getPreference = function (key) {
        return this.webStorageService
            .setup(webSessionStorageConfig)
            .get(key);
    };
    SessionService.prototype.removePreference = function (key) {
        this.webStorageService
            .setup(webSessionStorageConfig)
            .remove(key);
    };
    SessionService.prototype.removePreferenceStartsWith = function (startWith) {
        var keys = this.webStorageService.keys();
        keys.forEach(function (currentKey) {
            if (currentKey.indexOf(startWith) > -1 && typeof this.webStorageService.get(currentKey) !== 'function') {
                this.removePreference(currentKey);
            }
        }, this);
    };
    // TODO: Review this conversion
    SessionService.prototype.convertPreferencesToAngular2 = function () {
        var _this = this;
        Object.keys(sessionStorage)
            .forEach(function (preference) {
            if (preference.indexOf('Modulab.') > -1) {
                var preferenceName = preference.substring('Modulab.'.length);
                _this.putPreference(preferenceName, JSON.parse(localStorage.getItem(preference)));
            }
        });
    };
    return SessionService;
}());
SessionService.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
SessionService.ctorParameters = function () { return [
    { type: web_storage_1.WebStorageService, },
]; };
exports.SessionService = SessionService;
//# sourceMappingURL=session.service.js.map